"use strict";

(function(){

	// Module
	var app = angular.module('World', ['ngAnimate']);

	// Pagination Factory
	app.factory('pagination', function(){
		var currentPage = 1,
			itemsPerPage = 10,
			items = [];
		return {
			// устанавливаем конфигурацию пагинации
			setItems: function(data, perPage){
				items = data;
				itemsPerPage = angular.isUndefined(perPage) ? itemsPerPage : perPage;
			},
			// кол-во страниц
			getCountPages: function(){
				return Math.ceil(items.length / itemsPerPage);
			},
			getPaginationList: function(){
				var countPages = this.getCountPages(),
					pagination = [];
				if(countPages > 1){
					for(var i = 1; i <= countPages; i++){
						pagination.push(i);
					}
				}
				return pagination;
			}
		};
	});

	// Controllers
	app.controller('CountriesCtrl', ['$scope', '$http', 'orderByFilter', 'pagination', function($scope, $http, orderBy, pagination){
		$http.post('countries.php').
			success(function(res){
				$scope.countries = res;
				$scope.order = 'Code';
				$scope.reverse = false;
				$scope.perPage = 20;

				pagination.setItems(res, $scope.perPage);
				
				/*// $scope.page = 1; // текущая страница
				if(localStorage.getItem('page')){
					$scope.page = +localStorage.getItem('page');
				}else{
					$scope.page = 1;
					localStorage.setItem('page', 1);
				}
				$scope.perPage = 10; // записей на страницу
				$scope.countPages = Math.ceil($scope.countries.length / $scope.perPage);

				// номер предыдущей страницы
				$scope.prevPage = function(){
					$scope.page -= 1;
					localStorage.setItem('page', $scope.page);
					return $scope.page;
				};

				// номер следующей страницы
				$scope.nextPage = function(){
					$scope.page += 1;
					localStorage.setItem('page', $scope.page);
					return $scope.page;
				};

				// ограничение первой страницы
				$scope.firstPage = function(){
					return $scope.page == 1;
				};

				// ограничение последней страницы
				$scope.lastPage = function(){
					return $scope.page == $scope.countPages;
				};

				// выборка записей запрошенной страницы
				$scope.start = 	function(){
					return ($scope.page - 1) * $scope.perPage;
				}*/

			});
	}]);

})();